package cat.hack3.codingtests.marsrover;

public class CommandFactory {
    private final RotableRiderRover rover;

    public CommandFactory(RotableRiderRover rover) {
        this.rover = rover;
    }

    public RoverCommand createCommand(RoverCommand.Type type) {
        return switch (type) {
            case MOVE_FORWARD -> new MoveForwardCommand(rover);
            case MOVE_BACKWARDS -> new MoveBackwardsCommand(rover);
            case TURN_LEFT -> new TurnLeftCommand(rover);
            case TURN_RIGHT -> new TurnRightCommand(rover);
        };
    }
}
